class validationRules {

    constructor() {

    }

    string(label,value,min,max) {
        let regex = new RegExp('^[0-9A-Za-z., ]+$');
        if(!value){
            return label+" is Required";
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value)){
            return label+" pattern failed";        
        }
        return null
    }

    phone(label,value,min,max) {
        let regex = new RegExp('^[0-9]+$');
        if(!value){
            return label+" is Required";
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value)){
            return "Invalid Phone Number";        
        }
        return null
    }

    decimal_number(label,value,min,max) {
        let regex = new RegExp('^[0-9]+(\.[0-9]?[0-9])?$');
        if(!value){
            return label+" is Required";
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value)){
            return "Invalid Pattern";        
        }
        return null
    }

    email(label,value,min,max) {
        let regex = new RegExp('^([a-zA-Z0-9_\\-\\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$');
        if(!value){
            return label+" is Required";
        }
        if(!regex.test(value)){
            return "Invalid Email Id";        
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        return null
    }

    mobile(label,value,min,max) {
        let regex = new RegExp('^[6789][0-9]{9}');
        if(!value){
            return label+" is Required";
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value)){
            return "Invalid Mobile Number";        
        }
        return null
    }

    pan(label,value,min,max) {
        let regex = new RegExp('^[A-z]{5}[0-9]{4}[A-z]$');
        if(!value){
            return label+" is Required";
        }
        if(value.length < min){
            return label+" cannot be less than "+min;
        }
        if(value.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value)){
            return "Invalid PAN Number";        
        }
        return null
    }

    password(label,value1,value2,min,max) {
        let regex = new RegExp('^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.*[!@#\$%\^&\*])(?=.{6,20})');
        if(!value1){
            return label+" is Required";
        }
        if(value1.length < min){
            return label+" cannot be less than "+min;
        }
        if(value1.length > max){
            return label+" cannot be greater than "+max;
        }
        if(!regex.test(value1)){
            return "Password contains At least 1 lower case, 1 upper case, 1 numeric, 1 numeric and 1 special character";
        }
        if(value1 !== value2){
            return "Password and Confirm Password doesnot matched";
        }
        return null
    }

    boolean(label,value){
        let regex = new RegExp('^(true|false|1|0|on|off)$');
        if(!value){
            return label+" is Required";
        }
        if(!regex.test(value)){
            return "Required";
        }
        return null
    }

}

module.exports = validationRules;